// DemoAccessor.h
//	Copyright:	 1994 - 1998 by Apple Computer, Inc., all rights reserved.


#pragma once
#include "DemoIndex.h"

#ifdef DEMOINDEXISINVERTED
	#ifdef DEMOINDEXISVECTOR
		// InVecIndex: -- pick an accessor, any accessor
		/*
		#define DEMOACCESSORCLASS			VectorAccessor
		#include							"VectorAccessor.h"
		#define DEMOACCESSORINDEXCLASS		VectorIndex

		#define DEMOACCESSORCLASS			InvertedAccessor
		#include							"InvertedAccessor.h"
		#define DEMOACCESSORINDEXCLASS		InvertedIndex
		*/
		#define DEMOACCESSORCLASS			InVecAccessor
		#include							"InVecAccessor.h"
		#define DEMOACCESSORINDEXCLASS		InVecIndex
	#else
		// InvertedIndex --  use InvertedAccessor
		#define DEMOACCESSORCLASS			InvertedAccessor
		#include 							"InvertedAccessor.h"
		#define DEMOACCESSORINDEXCLASS		InvertedIndex
	#endif
#else
	#ifdef DEMOINDEXISVECTOR
		// VectorIndex -- use VectorAccessor
		#define DEMOACCESSORCLASS			VectorAccessor
		#include 							"VectorAccessor.h"
		#define DEMOACCESSORINDEXCLASS		VectorIndex
	#endif
#endif

class DemoAccessor : public DEMOACCESSORCLASS {
public:
		DemoAccessor(DEMOACCESSORINDEXCLASS** is, uint32 ic) : DEMOACCESSORCLASS(is, ic) {}
	
	void	Initialize();

	bool	IsHit(IAIndex* index, const IADoc* doc);
	char	firstChar;		// if non-NULL, hits are filtered to start w/ this
};
