// PowerPlantStoreStream.h
//	Copyright:	 1994 - 1998 by Apple Computer, Inc., all rights reserved.


// Subclass of HFSStoreStream that uses PowerPlant's support for threaded, asynch i/o.

#pragma once
#include "HFSStoreStream.h"

class PowerPlantStoreStream : HFSStoreStream {
public:
				PowerPlantStoreStream(short vRef, long dirId, const StringPtr fileName,
									  OSType creator = 'VTWN', OSType fileType = 'STOR');
//				PowerPlantStoreStream(PowerPlantStoreStream& s) : HFSStoreStream(s) {}

	virtual IAStoreStream*	Clone();
protected:
				// constructor for use by Clone()
				PowerPlantStoreStream(short vRef, long dirId, const StringPtr fileName,
									  OSType creator, OSType fileType, bool isOpen, bool isWritable,
							   		  short fRefNum);

	void					Write(uint32 address, const byte* data, uint32 length);
	uint32					Read(uint32 address, byte* data,  uint32 length);
};
